//
// Copyright 2007-2008 Christian Henning, Andreas Pokorny, Lubomir Bourdev
//
// Distributed under the Boost Software License, Version 1.0
// See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt
//
#ifndef BOOST_GIL_EXTENSION_IO_TIFF_DETAIL_SUPPORTED_TYPES_HPP
#define BOOST_GIL_EXTENSION_IO_TIFF_DETAIL_SUPPORTED_TYPES_HPP

#include <boost/gil/channel.hpp>
#include <boost/gil/color_base.hpp>

#include <boost/mpl/not.hpp>
#include <boost/type_traits/is_same.hpp>

namespace boost{ namespace gil {

namespace detail {

// Read support

// TIFF virtually supports everything
struct tiff_read_support : read_support_true
{};


// Write support

struct tiff_write_support : write_support_true
{};

} // namespace detail

template< typename Pixel >
struct is_read_supported< Pixel
                        , tiff_tag
                        >
    : mpl::bool_< detail::tiff_read_support::is_supported > {};

template< typename Pixel >
struct is_write_supported< Pixel
                         , tiff_tag
                         >
    : mpl::bool_< detail::tiff_write_support::is_supported >
{};

} // namespace gil
} // namespace boost

#endif
